<?php
/**
 * Created by PhpStorm.
 * User: piyuesh23
 * Date: 10/08/14
 * Time: 9:40 PM
 */

namespace Drupal\social_stats;


class SocialStatsQueueManager {
  public static function processQueue($result) {
    $facebook_total = 0;
    $twitter_shares = 0;
    $linkedin_shares = 0;
    $google_plusone = 0;

    $node_alias = 'node/'  .$result->nid;

    $variable = unserialize(\Drupal::config('social_stats.settings')->get('social_stats_content_types_' . $result->type));

    // Create absolute node path using the node path.
    $node_path = url($node_alias, array('absolute' => TRUE));

    // Getting data from Facebook for nodes of the selected node type.
    if ($variable['fb']) {
      $fb_baseurl = 'https://graph.facebook.com/fql?';
      $FbStatsManager = new SocialStatsFbManager($fb_baseurl, $node_path, $result->nid, 'get');
      $facebook_total = $FbStatsManager->execute();
    }

    // Getting data from Twitter for nodes of selected node type.
    if ($variable['twitter']) {
      $twitter_baseurl = 'http://urls.api.twitter.com/1/urls/count.json';
      $TwitterStatsManager = new SocialStatsTwitterManager($twitter_baseurl, $node_path, $result->nid, 'get');
      $twitter_total = $TwitterStatsManager->execute();
    }

    // Getting data from LinkedIn for nodes of selected node type.
    if ($variable['linkedin']) {
      $linkedin_baseurl = 'http://www.linkedin.com/countserv/count/share?format=json&';
      $LinkedinStatsManager = new SocialStatsLinkedinManager($linkedin_baseurl, $node_path, $result->nid, 'get');
      $linkedin_total = $LinkedinStatsManager->execute();
    }

//    // Getting data from Google Plus for nodes of selected node type.
   if ($variable['gplus']) {
     $google_data = new SocialStatsGplusManager($node_path, $result->nid);
   }

    $count_total = $facebook_total + $twitter_total;
    $count_total += $linkedin_total + $google_data;

    // Adding the total data from all above to get total virality.
    // Update table only when counter > 0
    if ($count_total) {
      db_merge('social_stats_total')
        ->key(array('nid' => $result->nid))
        ->fields(array('total' => $count_total))
        ->execute();
    }
  }
} 